import ./macros/base_place_block.mcm
import ./macros/base_break_block.mcm
import ./macros/knowledge_book_recipe.mcm


function load{
    scoreboard objectives add wasd.timer dummy
    scoreboard objectives add wasd.temp dummy
}


function give_items{
    give @s item_frame{display:{Name:'{"text":"Fake Block","italic":false}'},CustomModelData:6373001,wasd.secret_doors:1b,EntityTag:{Tags:["wasd.secret_doors","wasd.fake_block"],Facing:1b,Invulnerable:1b,Invisible:1b,Fixed:1b}} 1
    give @s item_frame{display:{Name:'{"text":"Fake Door","italic":false}'},CustomModelData:6373001,wasd.secret_doors:1b,EntityTag:{Tags:["wasd.secret_doors","wasd.fake_door"],Facing:1b,Invulnerable:1b,Invisible:1b,Fixed:1b}} 1

}




function placed_item_frame{
    tag @s add wasd.placing_fake_block
    advancement revoke @s only wasd.secret:detection/placed_item_frame
    execute as @e[type=item_frame,tag=wasd.secret_doors,distance=..10] at @s run function wasd.secret:check_placed_item_frame
    tag @s remove wasd.placing_fake_block
}

function check_placed_item_frame{
#first check if a chair is already at the location... and break if not (running function wasd.secret:break)
    execute if entity @e[type=item_display,distance=..0.001] run block{
        tag @s add wasd.break
        execute positioned ~ ~0.6 ~ run function wasd.secret:break
    }
    execute as @s[tag=!wasd.break] run block{
        execute as @s[tag=wasd.fake_block] run base_place_block fake_block 6373001 face_me
        execute as @s[tag=wasd.fake_door] run base_place_block fake_door 6373001 face_me
    }
    kill @s
}


function right_click{
    advancement revoke @s only wasd.secret:detection/right_click
    tag @s add wasd.right_click
    execute as @e[type=interaction,distance=..6,tag=wasd.secret_doors] at @s run block{
        scoreboard players set check_right_clicked wasd.temp 0
        execute on target store result score check_right_clicked wasd.temp if entity @s[tag=wasd.right_click]
        execute if score check_right_clicked wasd.temp matches 1 at @s run block{
            execute if data entity @p[tag=wasd.right_click,distance=..6] SelectedItem unless data entity @p[tag=wasd.right_click,distance=..6] SelectedItem.tag run block{
                execute unless entity @s[tag=wasd.disguised] run block{
                    execute positioned ~ ~0.04 ~ run block{
                        summon block_display ~ ~ ~ {block_state:{Name:"minecraft:air"},Tags:["wasd.valid_block_check"]}
                        execute positioned ~ ~ ~ run data modify entity @e[tag=wasd.valid_block_check,sort=nearest,limit=1] block_state.Name set from entity @p[tag=wasd.right_click,distance=..6] SelectedItem.id
                        execute positioned ~ ~ ~ unless entity @e[tag=wasd.valid_block_check,sort=nearest,limit=1,nbt={block_state:{Name:"minecraft:air"}}] run block{
                            data modify entity @e[tag=wasd.secret_doors,sort=nearest,limit=1,distance=..0.01] item.id set from entity @p[tag=wasd.right_click,distance=..6] SelectedItem.id
                            data remove entity @e[tag=wasd.secret_doors,sort=nearest,limit=1,distance=..0.01] item.tag
                            item modify entity @p[tag=wasd.right_click,distance=..6,gamemode=!creative] weapon.mainhand wasd.secret:remove1
                            tag @s add wasd.disguised
                        }
                        kill @e[type=block_display,tag=wasd.valid_block_check,sort=nearest,limit=1]
                    }
                }
            }
            execute as @s[tag=wasd.fake_door] unless data entity @p[tag=wasd.right_click,distance=..6] SelectedItem run block{
                name open_close
                scoreboard players add @s wasd.timer 1
                tag @s add wasd.fake_door_changing
                execute positioned ~1 ~ ~ as @e[tag=wasd.secret_doors,tag=wasd.fake_door,tag=!wasd.fake_door_changing,sort=nearest,limit=1,distance=..0.01] at @s run function wasd.secret:open_close
                execute positioned ~-1 ~ ~ as @e[tag=wasd.secret_doors,tag=wasd.fake_door,tag=!wasd.fake_door_changing,sort=nearest,limit=1,distance=..0.01] at @s run function wasd.secret:open_close
                execute positioned ~ ~1 ~ as @e[tag=wasd.secret_doors,tag=wasd.fake_door,tag=!wasd.fake_door_changing,sort=nearest,limit=1,distance=..0.01] at @s run function wasd.secret:open_close
                execute positioned ~ ~-1 ~ as @e[tag=wasd.secret_doors,tag=wasd.fake_door,tag=!wasd.fake_door_changing,sort=nearest,limit=1,distance=..0.01] at @s run function wasd.secret:open_close
                execute positioned ~ ~ ~1 as @e[tag=wasd.secret_doors,tag=wasd.fake_door,tag=!wasd.fake_door_changing,sort=nearest,limit=1,distance=..0.01] at @s run function wasd.secret:open_close
                execute positioned ~ ~ ~-1 as @e[tag=wasd.secret_doors,tag=wasd.fake_door,tag=!wasd.fake_door_changing,sort=nearest,limit=1,distance=..0.01] at @s run function wasd.secret:open_close
                execute as @s[scores={wasd.timer=1}] run block{
                    setblock ~ ~1 ~ air
                    execute positioned ~ ~0.04 ~ run data merge entity @e[tag=wasd.secret_doors,tag=wasd.fake_door,sort=nearest,limit=1,distance=..0.01] {start_interpolation:0,interpolation_duration:10,transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,0.47f,-0.45f],scale:[1.01f,1.01f,0.1f]}}
                }
                execute as @s[scores={wasd.timer=2}] run block{
                    setblock ~ ~1 ~ barrier
                    execute positioned ~ ~0.04 ~ run data merge entity @e[tag=wasd.secret_doors,tag=wasd.fake_door,sort=nearest,limit=1,distance=..0.01] {start_interpolation:0,interpolation_duration:10,transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,0.47f,0f],scale:[1.01f,1.01f,1.01f]}}
                    scoreboard players reset @s wasd.timer
                }
                schedule function wasd.secret:fake_door_changing 1t
            }
        tag @p[tag=wasd.right_click,distance=..6] remove wasd.right_click
        data remove entity @s interaction
        tag @s remove wasd.right_click
        }
    }
}

function fake_door_changing{
    tag @e[tag=wasd.fake_door_changing] remove wasd.fake_door_changing
}


function left_click{
    advancement revoke @s only wasd.secret:detection/left_click
    tag @s add wasd.left_click
    execute as @e[type=interaction,distance=..6,tag=wasd.secret_doors] at @s run block{
        scoreboard players set check_left_clicked wasd.temp 0
        execute on attacker store result score check_left_clicked wasd.temp if entity @s[tag=wasd.left_click]
        execute if score check_left_clicked wasd.temp matches 1 at @s run block{
            function wasd.secret:break
            execute positioned ~ ~0.04 ~ run kill @e[tag=wasd.secret_doors,sort=nearest,limit=1,distance=..0.001]
            kill @s
        }

    }
    tag @s remove wasd.left_click

}


function break{
    execute as @s[tag=wasd.fake_block] run base_break_block fake_block
    execute as @s[tag=wasd.fake_door] run base_break_block fake_door

}

dir recipes{
    function recipes{
        knowledge_book_recipe fake_block fake_block
        knowledge_book_recipe fake_door fake_door

    }
}